#include <stdio.h>
/* check a string
  don't check overlong sequences

  0 ok
  1 invalid multibyte sequence on the first byte
  2 invalid multibyte sequence on the second byte
  3 invalid multibyte sequence on the third byte
  4 invalid multibyte sequence on the fourth byte
  5 unfinished multibyte sequence
  6 invalid codepoint
*/

//#undef  pathcrawler_label
//#define pathcrawler_label(cond)   {} // DSE(p)
//#define pathcrawler_label(cond)   { if(cond) {printf("\nlabelCondTrue('%s:%d')\n",__FILE__, __LINE__);} } // DSE(p')
// DSE(p*) tout commenter + disable_label_history(yes)
// DSE*(p*) tout commenter

int check (unsigned char* buffer, int n) {
  int error = 0;


  for (int i = 0; error == 0 && i < n; i++) {
    
    pathcrawler_label(error == 0);
    pathcrawler_label(error != 0);
    pathcrawler_label(i<n);
    pathcrawler_label(i>=n);
    


    unsigned char c = buffer[i];
    unsigned int codepoint = 0;

    
    pathcrawler_label(c < 128); 
   pathcrawler_label(c >= 192); 
   pathcrawler_label(c < 224); 
   pathcrawler_label(c < 240); 
   pathcrawler_label(c < 248); 
    pathcrawler_label(c >= 128); 
   pathcrawler_label(c < 192); 
   pathcrawler_label(c >= 224); 
   pathcrawler_label(c <= 240); 
   pathcrawler_label(c >= 248); 
    

    if (c < 128) {
      codepoint = c;
    } else if (c >= 192 && c < 224) { 


      
      pathcrawler_label(c-192 != c+192); 
      pathcrawler_label(c-192 != c*192);  
      pathcrawler_label(c-192 != c); 
     pathcrawler_label(c-192 != c/192);  
      

      codepoint = c - 192;

      if (i+1 < n) {
        c = buffer[++i];

        if (c >= 128 && c < 192) { 

	  
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c * 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint + 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint / 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint - 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint  + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  64  + (c + 128) ); 
	  
	  

          codepoint = codepoint * 64 + (c - 128);
        } else {
          error = 2;
        }
      } else {
        error = 5;
      }
    } else if (c >= 224 && c < 240) {
      codepoint = c - 224;
      if (i+2 < n) {
        c = buffer[++i];
        if (c >= 128 && c < 192) { 

	  
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c * 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint + 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint / 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint - 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint  + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  64  + (c + 128) ); 
	  
          codepoint = codepoint * 64 + (c - 128);
          c = buffer[++i];
          if (c >= 128 && c < 192) {
	    
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c * 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint + 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint / 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint - 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint  + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  64  + (c + 128) ); 
	  
            codepoint = codepoint * 64 + (c - 128);
          } else {
            error = 3;
          }
        } else {
          error = 2;
        }
      } else {
        error = 5;
      }
    } else if (c >= 240 && c < 248) {
      codepoint = c - 240;
      if (i+3 < n) {
        c = buffer[++i];
        if (c >= 128 && c < 192) {
	  
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c * 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint + 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint / 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint - 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint  + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  64  + (c + 128) ); 
	  
          codepoint = codepoint * 64 + (c - 128);
          c = buffer[++i];
          if (c >= 128 && c < 192) {
	    
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c * 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint + 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint / 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint - 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint  + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  64  + (c + 128) ); 
	    
            codepoint = codepoint * 64 + (c - 128);
            c = buffer[++i];
            if (c >= 128 && c < 192) {
	      
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c * 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (c) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint * 64 + (128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint + 64 + (c + 128) );  
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint / 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint - 64 + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  codepoint  + (c + 128) ); 
	  pathcrawler_label(codepoint * 64 + (c - 128)  !=  64  + (c + 128) );  //here

              codepoint = codepoint * 64 + (c - 128);
            } else {
              error = 4;
            }
          } else {
            error = 3;
          }
        } else {
          error = 2;
        }
      } else {
        error = 5;
      }
    } else {
      error = 1;
    }

    
    pathcrawler_label(codepoint >= 0xD7FF);
    pathcrawler_label(codepoint <= 0xD7FF);
    pathcrawler_label(codepoint > 0xD7FF);
    pathcrawler_label(codepoint < 0xD7FF);
    pathcrawler_label(codepoint == 0xD7FF);
    pathcrawler_label(codepoint != 0xD7FF);

    pathcrawler_label(codepoint >= 0xE000);
    pathcrawler_label(codepoint <= 0xE000);
    pathcrawler_label(codepoint > 0xE000);
    pathcrawler_label(codepoint < 0xE000);
    pathcrawler_label(codepoint == 0xE000);
    pathcrawler_label(codepoint != 0xE000);
    
    

    if (codepoint > 0xD7FF && codepoint < 0xE000) {
      error = 6;
    }
  }
  return error;
}


#define N 3

//extern 
unsigned char buffer[N];

int main() {

/*  unsigned char t[] = { 'a', 'b', 'c'};*/

/*  if (check(t, 3) == 0) passed += 1;*/

  int passed = check(buffer, N);

  return passed;
}
